
%% ====================================================================
%% Types
%% ====================================================================

-record(pingstate, {
    ctx % ets of states
  }).

%% ---------------------------

-record(media, {
    stage=start, % start|dlg - invite...200 -> start, reinvite..200 -> dlg
    mgc, % media-gate-controller
    msid, % media-session id (generated by every request/response)
    mgid, % media-gate id (got from mgc on context creation)
    ctx, % context_id (got from mgc on context creation)
    %
    start_opts=[], % opts of starting
    allow_transcoding, % boolean()
    is_rec=true, % context is recorded
    timestamp :: integer(), % invite time stamp to build rec path
    rec_links=[], % [{MG,Ctx,Timestamp,RecPath}] opts of context's mg trace (where to find records
    %
    caller, % term of caller -> template modified by mg into real data
    callee, % term(s) of callee -> template modified by mg into real data
    caller_tag,
    callee_tag,
    caller_opts,
    callee_opts,
    %
    ivr, % term of ivr (player)
    %
    external_terms = [], % terms of external: rtp prompter, rtp listener, record stenography, play ding, record specific
    external_topology = [], % topology for external terms
    %
    re_opts=[],
    refer=undefined
  }).

-record(reopts, {
    cseq,
    ftag,
    fsdp_r,
    fsdp_l,
    ttag,
    tsdp_r,
    tsdp_l,
    %
    toside,
    tsdpd_l_prev,
    tsdpd_base_prev
  }).

%% ----------------------------
-record(media_conf, {
    stage=start,
    mgc, % media-gate-controller
    msid, % media-session id (generated by every request/response)
    mgid, % media-gate id (got from mgc on context creation)
    ctx, % context_id (got from mgc on context creation)
    %
    is_rec = false, % context is recorded
    rec_links=[], %  [{MG,Ctx,Timestamp,RecPath}]  opts of context's mg trace (where to find records)
    %
    is_video = false, % context has video processor
    video_screen_schema=#{}, % screen schema json settings
    %
    terms = [], % list of term tuples: [{callid, #term_conf{}}]
    players = [], % list of {PlayerId::term(), Term::{Type,Id,Opts}}
    recorders = [] % list of {RecId::term(), Term::{Type,Id,Opts}}
  }).

-record(term_conf, {
    dir, % in|out
    callid,
    tag,
    term_type,
    term_id,
    term,
    sdp_o,
    sdp_r,
    sdp_l_base
  }).

%% ----------------------------
-record(media_ivr, {
    stage=start,
    mgc, % media-gate-controller
    msid, % media-session id (generated by every request/response)
    mgid, % media-gate id (got from mgc on context creation)
    ctx, % context_id (got from mgc on context creation)
    %
    players = [], % list of {PlayerId::term(), Term::{Type,Name,Opts}}
    recorders = [], % list of {RecorderId::term(), Term::{Type,Name,Opts}}
    fax = undefined, % Term::{Type,Name,Opts}
    %
    terms = [] % list of term tuples: [{callid, #term_ivr{}}]
  }).

-record(term_ivr, {
    dir, % in|out
    callid,
    tag,
    term_type,
    term_id,
    term,
    term_events,
    sdp_o,
    sdp_r,
    sdp_l_base
  }).

-record(term_ivr_player, {
    term_id,
    term
  }).

-record(term_ivr_recorder, {
    term_id,
    term
  }).

-record(term_ivr_fax, {
    term_id,
    term
  }).

%% ----------------------------
-record(media_mrcp, {
    stage=start,
    mgc, % media-gate-controller
    msid, % media-session id (generated by every request/response)
    mgid, % media-gate id (got from mgc on context creation)
    ctx, % context_id (got from mgc on context creation)
    %
    terms = [] % list of term tuples: [{callid, #term_ivr{}}]
  }).

-record(term_mrcp, {
    dir, % in|out
    callid,
    tag,
    term_type,
    term_id,
    term,
    sdp_o,
    sdp_l_descr_base, % templated sdp-descriptor, only basic rtp stream in local sdp (used in MEGACO)
    sdp_l_descr_megaco, % megaco sdp-descriptor, only basic rtp stream in local sdp (used in MEGACO)
    sdp_l_megaco, % #sdp, only basic rtp stream in local sdp
    sdp_l_mrcp, % #sdp, contains mrcp extension application stream in local sdp (used in MRCP-SIP-request)
    sdp_r_mrcp, % #sdp, contains mrcp extension application stream in remote sdp (got from MRCP-SIP-response)
    sdp_r_megaco, % #sdp, only basic rtp stream in remote sdp
    sdp_r_descr_megaco % megaco sdp-descriptor, only basic rtp stream in remote sdp (used in MEGACO)
  }).

%% ====================================================================
%% Define modules
%% ====================================================================

-define(MGC, r_sip_mgc_adapter).
-define(MGC_PINGER, r_sip_mgc_context_pinger_srv). % CTXPING
-define(MGC_TERM, r_sip_mgc_term_routines). % TERM
-define(D_SDP, r_sip_sdp_description_routines). % SDPD

-define(MEDIA_CONF, r_sip_media_lib_conf).
-define(MEDIA_IVR, r_sip_media_lib_ivr).
-define(MEDIA_MRCP, r_sip_media_lib_mrcp).

-define(MEDIA_B2B, r_sip_media_lib_b2b).
-define(M_B2B_OA, r_sip_media_lib_b2b_oa).
-define(M_B2B_FWD, r_sip_media_lib_b2b_fwd).
-define(M_B2B_RE, r_sip_media_lib_b2b_fwd_reinvite).
-define(M_B2B_MIGRATE, r_sip_media_lib_b2b_migrate).
-define(M_B2B_REFER, r_sip_media_lib_b2b_refer).
-define(M_B2B_REPLACES, r_sip_media_lib_b2b_replaces).
-define(M_B2B_PROMPT, r_sip_media_lib_b2b_prompt).
-define(MEDIA_GATE, r_sip_media_lib_gate).

-define(MEDIA_SESSCHANGE, r_sip_media_sesschange).

-define(M_SDP, r_sip_sdp_media_routines).

-define(LO, ?M_SDP:lo).
-define(LO_REDUCE, ?M_SDP:lo_reduce).
-define(SENDRECV, ?M_SDP:sendrecv).
-define(SENDONLY, ?M_SDP:sendonly).
-define(RECVONLY, ?M_SDP:recvonly).
-define(INACTIVE, ?M_SDP:inactive).
-define(UNZEROIP, ?M_SDP:unzero_ip).

%% ====================================================================
%% Define other
%% ====================================================================
